import java.awt.*;
import java.util.*; 
import java.io.*;


class create_panel extends Panel
{
    File FileSelected,DirSelected;
    Panel work_panel,comment_panel,name_panel,command_panel ;
    Date progdate;
    String FileLst[];
    Font f; 
    int day,month,a,Size,Width = 17;
    long y;
    String DirName,sItem,x,str;
    List ListBox;
    StringBuffer s; 
    Label comments;
    sc  parent;

    public create_panel(sc frame)    
    {
	parent = frame;
        ListBox = new List();
        work_panel = new Panel();
        comment_panel = new Panel();
        name_panel = new Panel();
	s = new StringBuffer();
	Size = 12;
	f = new Font("Courier",Font.BOLD,Size);
        setLayout(new BorderLayout());
        add("North",name_panel);
	name_panel.setLayout(new GridLayout(1,4));
	name_panel.add(new Label(" NAME "));
	name_panel.add(new Label("    SIZE"));
        name_panel.add(new Label("  DATE"));
	name_panel.add(new Label(" TIME"));
        add("South",comment_panel);
        work_panel.setLayout(new GridLayout(1,4));
	add("Center",work_panel);
	work_panel.add(ListBox);
	FileSelected = new File(System.getProperty("user.dir"));
	comments = new Label(FileSelected.toString()); 
    	DirName = FileSelected.toString();
	DirSelected = new File(DirName);
        FileLst = FileSelected.list();	
  }



     public void leftmenu()
     {
	comment_panel.setLayout(new GridLayout(3,1));
	comment_panel.add(comments);
	command_panel = new Panel();
	command_panel.setLayout(new GridLayout(1,4));
	command_panel.add(new Button("F1: Copy"));
	command_panel.add(new Button("F2: Delete"));
	command_panel.add(new Button("F3: Move"));
	command_panel.add(new Button("F4: View"));
	comment_panel.add(command_panel);
        comment_panel.add(new Label("  "));

     }


     public void rightmenu()
     {
	comment_panel.setLayout(new GridLayout(3,1));
	comment_panel.add(comments);
	command_panel = new Panel();
	command_panel.setLayout(new GridLayout(1,4));
	command_panel.add(new Button("F5: Search"));
	command_panel.add(new Button("F6: MkDir"));
	command_panel.add(new Button("F7: Rename"));
	command_panel.add(new Button("F8: Quit"));
	comment_panel.add(command_panel);
        comment_panel.add(new Label("  "));
     }

     public void SetSize(int s)
     {
        Size = s;
	f = new Font("Courier",Font.BOLD,Size);
	ListBox.delItems(0,FileLst.length);
        ListRe_enter();
     }
    
     public void SetCharWidth(int w)
     {
	Width = w;
	ListBox.delItems(0,FileLst.length);
	ListRe_enter();
     }
     public void ListEnter()
     {
        ListBox.addItem("..");	
	for (int i=0;i<FileLst.length;i++)
	   ListAdd(FileLst[i],ListBox);
	ListBox.select(1);
     }
           
	
    public void ListRe_enter()
     {
	List TempListBox = new List(); 
	TempListBox.addItem("..");
	for (int i=0;i<FileLst.length;i++)
	   ListAdd(FileLst[i],TempListBox);
	TempListBox.select(1);

	work_panel.remove(ListBox);
	ListBox = TempListBox;
	work_panel.add(ListBox);
	//work_panel.show();

	ListBox.invalidate();
	work_panel.validate();	

     }

     public void UpdateItem(String FileName,String Dir,boolean flag1)
     { 
          DirName = Dir;
	  System.out.println("Path="+Dir);
          ListAdd(FileName,ListBox);
	  if (flag1)
	  {
	     StringTokenizer st = new StringTokenizer(DirName,File.separator);
             int n = st.countTokens();
       	     DirName = File.separator+st.nextToken();
	     n = n-2;
             while(n!=0)
	     {
	         DirName = DirName+File.separator+st.nextToken();
	         n--;
             }
	  }
	  System.out.println("After"+DirName);
     }       


     public void SetNewName(String NewName,String Dir)
     {
	 DirName =Dir;
	 int index = ListBox.getSelectedIndex();
	 ListBox.delItem(index);
	 ListAdd(NewName,ListBox);   
     }

     public void DelSelectedIndex(String Dir)
     {
	 int index =  ListBox.getSelectedIndex();
         ListBox.delItem(index);      
	 ListBox.select(2);
	 FileSelected = new File(Dir);
	 if (FileSelected.exists())
	     System.out.println("Exists");
	 FileLst = FileSelected.list();
     }

     public void ListAdd(String FileName,List ListBox)
     {
	   String z,m;
           File newfile = new File(DirName,FileName);
	   if (newfile.isDirectory())
		x = "<DIR>";		   
           else
           {		
           	long len = newfile.length();
	   	if (len<10) x = "    "+len;
	   	if ((len<100)&&(len>=10))  x = "   "+len; 
	   	if ((len>=100)&&(len<1000)) x = "  "+len;
	   	if ((len>=1000)&&(len<10000)) x = " "+len;
		if (len>=10000)  x= ""+len;
	   }  
	   if (FileName.length()<=Width)
	   {
		 s = new StringBuffer();
	  	 s.append(FileName);
		 int a = s.length();
	   	 while (a<Width)
           	 {
  			s.append(' ');
			a = a+1;
            	 } 	
          }	
          else
	  {
		String temp = FileName.substring(0,Width);	
		s = new StringBuffer();
		s.append(temp);
	  }
	      

	   y = newfile.lastModified(); 
	   progdate = new Date(y);
	   day = progdate.getDate();
	   if (day<10)
	          z= " "+"0"+day;
           else
	         z = " "+day;
           month = progdate.getMonth()+1; 		
           if (month<10)
		 m = "-"+"0"+month;
           else
		 m = "-"+month;
	  /* int hour = progdate.getHours();
	   if (hour<10)
	        h = ' '+hour;
	   else
		h = hour;*/

         sItem = s.toString()+" "+x+" "+z+m+"-"+progdate.getYear()+"    "+progdate.getHours()+":"+progdate.getMinutes();
	   setFont(f);
	   ListBox.addItem(sItem);
        }
  

    public String GetSelectedItem()
    {
	str = ListBox.getSelectedItem();
	str = str.substring(0,Width);
	return(str.trim());
    }


    public boolean action(Event evt,Object arg)
    {
	if (evt.target instanceof List)
	{
            String str = ListBox.getSelectedItem();
	   
	    if (str.equals(".."))
		  GetParentDirList();
            else
	          GetDirList(str);	   
	   
	    return true;
        }
	return false;
    }
    
     public String DirPathName()
     {
	return(DirName);
     } 

     public boolean gotFocus(Event evt,Object obj)
     {
	parent.SetActive(this);
	return false;
     }
     

    public void sorting(File fileobj)
    {
	 ListBox.delItems(0,FileLst.length);
	 String[] Lst =fileobj.list();
	 if (fileobj.exists())
	    System.out.println("File Exists .. in create");

	 int k=1;
	 //for(int i=0;i<FileLst.length;i++)
	    System.out.println(Lst[2]);
	 System.out.println("Num = "+FileLst.length);
	 System.out.println("Nums = ");
	 int n = FileLst.length;
	 boolean pass = true;
	 while (pass &(k<=n-1))
	 {
	    pass = false;
	    for(int i=0;i<n-k;i++)
            {
		 if ((FileLst[i].compareTo(FileLst[i+1]))>0)
		 {
		     String temp = FileLst[i];
		     FileLst[i] = FileLst[i+1];
		     FileLst[i+1] = temp;
		     pass = true;
		 }
            }
	    k=k+1;
         }
        ListRe_enter(); 
     }


    public void sortdate(File fileobj)
    {
	 ListBox.delItems(0,FileLst.length);
	 String[] Lst =fileobj.list();
	 if (fileobj.exists())
	    System.out.println("File Exists .. in create");

	 int k=1;
	 int n = FileLst.length;
	 boolean pass = true;
	 while (pass &(k<=n-1))
	 {
	    pass = false;
	    for(int i=0;i<n-k;i++)
            {
		 File FirFile = new File(DirName,FileLst[i]);
		 File SecFile = new File(DirName,FileLst[i+1]);
	         long y1 = FirFile.lastModified(); 
		 long y2 = SecFile.lastModified();
	         progdate = new Date(y1);
	         Date progdate2 = new Date(y2);
	         int day1 = progdate.getDate();
	         int day2 = progdate2.getDate();
		 int month1 = progdate.getMonth();
		 int month2 = progdate2.getMonth(); 
		 if (month1 > month2)
		 {
		     String temp = FileLst[i];
		     FileLst[i] = FileLst[i+1];
		     FileLst[i+1] = temp;
		     pass = true;
		 }
		 if (month1 == month2)
		 {
                     if (day1 > day2)
	             {
  			String temp = FileLst[i];
			FileLst[i] = FileLst[i+1];
			FileLst[i+1] = temp;
			pass = true;
		     } 
		 }

            }
	    k=k+1;
         }
        ListRe_enter(); 
    
    }



    public void sortsize(File fileobj)
    {
	 ListBox.delItems(0,FileLst.length);
	 String[] Lst =fileobj.list();
	 if (fileobj.exists())
	    System.out.println("File Exists .. in create");

	 int k=1;
	 //for(int i=0;i<FileLst.length;i++)
	    System.out.println(Lst[2]);
	 int n = FileLst.length;
	 boolean pass = true;
	 while (pass &(k<=n-1))
	 {
	    pass = false;
	    for(int i=0;i<n-k;i++)
            {
	         File FirFile = new File(DirName,FileLst[i]);
	         File SecFile = new File(DirName,FileLst[i+1]); 
		 if (FirFile.length()>SecFile.length())
		 {
		     String temp = FileLst[i];
		     FileLst[i] = FileLst[i+1];
		     FileLst[i+1] = temp;
		     pass = true;
		 }
            }
	    k=k+1;
         }
        ListRe_enter(); 
}


    public void GetParentDirList()
    {
	System.out.println(DirName);
	StringTokenizer st = new StringTokenizer(DirName,File.separator);
        int n = st.countTokens();
       	if (n != 1)       
  	{
             System.out.println("n = "+n); 
	     ListBox.delItems(0,FileLst.length);
       	     DirName = File.separator+st.nextToken();
	     n = n-2;
             while(n!=0)
	     {
	        DirName = DirName+File.separator+st.nextToken();
	       	n--;
             }
       	     System.out.println(DirName);
	     DirSelected = new File(DirName.toString());
	     if (DirSelected.isDirectory()) 
  			System.out.println("is Directory");
	    FileLst = DirSelected.list();
	    //TempListBox.clear();
	    ListRe_enter();
	    comments.setText(DirName);
       }
   }

	    
	  public void GetDirList(String str) 
	  {
	       str = str.substring(0,Width);
	       System.out.println(DirName);
	       DirSelected = new File(DirName+File.separator+str.trim()); 
	       System.out.println("Before checking..");
	       if (DirSelected.isDirectory())
	       {
		   System.out.println("inside loop");
	           DirName = DirName+File.separator+str.trim();
	           comments.setText(DirName);
        	   ListBox.delItems(0,FileLst.length); 
		   FileLst = DirSelected.list();
		   ListRe_enter();
               } 
          } 
}
