import java.io.*;
import java.awt.*;
import java.util.*;

class messgbox extends Dialog 
{
  public static final int OK = 1;
  public static final int CANCEL = 2;
  public static final int RETRY = 4;

  TextField  source = new TextField(16);
  TextField dest = new TextField(16);

  Frame parent = null;
  Button Ok = new Button("OK");
  Button Cancel = new Button("Cancel");
  Button Retry  = new Button("Retry");
  int Buttonpressed = 0;
  messgbox  (Frame parent,String title)
  {
  	super(parent,title,true);
	this.parent= parent;
	resize(100,100);
  }
  public int  disply(String mesg,int button,boolean flag2,boolean flag)
  {
	StringTokenizer st = new StringTokenizer(mesg,"\n");
	int count = st.countTokens(); 
	setLayout( new GridLayout(count+5,1));
        add(new Label(""));
	while (st.hasMoreTokens())
	   	add(new Label(st.nextToken(),Label.CENTER));
        Panel text1_panel = new Panel(); 
        Panel text2_panel = new Panel();
     	text1_panel.add (new Label("      Name :", Label.RIGHT));
     	text1_panel.add(source); 
     	if (flag)
     	{ 
	  if (flag2) 
		text2_panel.add(new Label("Start From :",Label.RIGHT));
	  else
     		text2_panel.add (new Label("     To  : ",Label.RIGHT)); 
     		text2_panel.add(dest);
        }
	if (flag2)
	    dest.setText("/export/home/java/latha");
        add(text1_panel);
	add(text2_panel);
	Panel Button_panel = new Panel();
        if ((button & 1)==1)
	    Button_panel.add(Ok);
	if ((button & 2) == 2)
	    Button_panel.add(Cancel);
	if ((button & 4) == 4)
	    Button_panel.add(Retry);
        add("Center",Button_panel); 
	pack();
	setResizable(false);
	show();
	return Buttonpressed;
  }
   
  public void DisplaySelectedItem(String Item)
  {
        source.setText(Item); 
  }

  public void DisplayPath(String path)
  {
	dest.setText(path.toString());
  }

  public boolean action(Event evt,Object obj)
  {
  	if (evt.target == Ok)
	   {
	     Buttonpressed = 1;
	     dispose();
	     return true;
           }
        if (evt.target == Cancel)
	   {
	     Buttonpressed = 2;
	     dispose();
	     return true;
           }
        if (evt.target == Retry)
	   {
	     Buttonpressed = 4;
	     dispose();
	     return true;
           }
	return true;
   }

   
   public String GetTextSource()
   {
  	return(source.getText());
   }

   public String GetTextDest()
   {
	return(dest.getText());
   }
}









