// sc.java: GUI based sheel commander

import java.awt.*;
import java.util.*; 
import java.io.*;

public class sc extends Frame
{
    create_panel left_panel;
    create_panel right_panel;
    create_panel active,inactive;
    menuclass menubox;
    String item,DirName1,DirName2;
    boolean found = false;
    boolean flag =false;
    boolean flag1;
    boolean flag2 = false;
    int num=0;
    int Size,Width;
    String[] Flist;

    public sc(String title)
    {
	super(title);
    	left_panel = new create_panel(this);
    	right_panel = new create_panel(this);
    }

    public void  init()
    {
       setLayout(new GridLayout(1,2));
       add(left_panel);
       add(right_panel);
       left_panel. ListEnter();
       right_panel.ListEnter();
       left_panel.leftmenu();
       right_panel.rightmenu();
       left_panel.show();
       right_panel.show();
    }

    
    public static void main (String[] args)
    {
        sc f = new sc("Shell Commander in Java");
        menuclass menubox = new menuclass(f);
        f.setMenuBar(menubox);
	f.resize(300,400);
	f.init();
        f.show();
    }
	
    public void SetActive(create_panel x)
    {
	active = x;
	if (active == right_panel)
	    inactive = left_panel;
	else
	    inactive = right_panel; 
    }

    
    
    public void Update()
    {
	if (flag2)
	{
	    flag1 = false;
	    flag2 = false;
	}
        if (flag)
        {
	   num++;
	   System.out.println("source dir");
	   if (num == Flist.length) 
	   {
	       for(int i=0;i<Flist.length;i++)
	          inactive.UpdateItem(Flist[i],DirName1,flag1); 
	   }   
        }
        else
	   inactive.UpdateItem(item,DirName2,flag1);
	flag1 = false;
    }   


  public boolean  handleEvent(Event evt)
  {
       if (evt.id == Event.WINDOW_DESTROY)
            System.exit(0);
       if (evt.target instanceof MenuItem)
       {
	     if (evt.arg.equals("Copy"))
		   CopyFile();
	     if (evt.arg.equals("Delete"))
		   DeleteFile();
	     if (evt.arg.equals("Rename"))
		   RenameFile();
             if (evt.arg.equals("Move"))
		   MoveFile();
             if (evt.arg.equals("Search"))
		   SearchFile();
             if (evt.arg.equals("Properties"))
		   FileProperty();
             if (evt.arg.equals("MakeDir"))
		   MakeDir();
	     if (evt.arg.equals("Quit"))
		   QuitShell();
	     if (evt.arg.equals("Sort by Name"))
		   SortByName();
             if (evt.arg.equals("Sort by Size"))	
		   SortBySize();
             if (evt.arg.equals("Sort by Date"))
		   SortByDate();
             if (evt.arg.equals("View"))
                   FileView(); 
             if (evt.arg.equals("About help"))
		   HelpMesg d16 = new HelpMesg(this);
             if (evt.arg.equals("More help"))
		   HelpDetail d17 = new HelpDetail(this);
             if (evt.arg.equals("10"))
             {
		   Size = 10;
		   active.SetSize(Size);
		   inactive.SetSize(Size);
             }
             if (evt.arg.equals("12"))
             {
		   Size = 12;
		   active.SetSize(Size);
		   inactive.SetSize(Size);
             }
             if (evt.arg.equals("14"))
             {
		   Size = 14;
		   active.SetSize(Size);
		   inactive.SetSize(Size);
             }
             if (evt.arg.equals("16"))
             {
		   Size = 16;
		   active.SetSize(Size);
		   inactive.SetSize(Size);
             }
             if (evt.arg.equals("18"))
             {
		   Size = 18;
		   active.SetSize(Size);
		   inactive.SetSize(Size);
             }
	     if (evt.arg.equals("11"))
	     {
		   Width = 11;
		   active.SetCharWidth(Width);
		   inactive.SetCharWidth(Width);
             }	
	     if (evt.arg.equals("13"))
	     {
		   Width = 13;
		   active.SetCharWidth(Width);
		   inactive.SetCharWidth(Width);
             }	
	     if (evt.arg.equals("15"))
	     {
		   Width = 15;
		   active.SetCharWidth(Width);
		   inactive.SetCharWidth(Width);
             }	
	     if (evt.arg.equals("17"))
	     {
		   Width = 17;
		   active.SetCharWidth(Width);
		   inactive.SetCharWidth(Width);
             }	
	     if (evt.arg.equals("20"))
	     {
		   Width = 20;
		   active.SetCharWidth(Width);
		   inactive.SetCharWidth(Width);
             }	
       }
       else
       {
	     if (evt.id == Event.KEY_ACTION)
	     {
		if((evt.evt != null)&&(evt.evt.id == Event.KEY_ACTION))
		{
			;
	        }	
             	else if (evt.key == Event.F1) CopyFile();
	        else if (evt.key == Event.F2) DeleteFile(); 
		else if (evt.key == Event.F3) MoveFile();
		else if (evt.key == Event.F4) FileView(); 
		else if (evt.key == Event.F5) SearchFile();
		else if (evt.key == Event.F6) MakeDir(); 
		else if (evt.key == Event.F7) RenameFile();
		else if (evt.key == Event.F8) QuitShell();
	     }
       }
       return  super.handleEvent(evt);
  } 


	 
           public void CopyFile() 
	   {
		 flag1 =false;
		 item = active.GetSelectedItem(); 
		 DirName1 =  active.DirPathName();
                 DirName2 = inactive.DirPathName();
		 String str1 = DirName1+File.separator+item; 
		 File source_file = new File(DirName1,item);
		 if (source_file.isDirectory())
		 {
		      Dialogbox d10 = new Dialogbox("Source given is Directory? Should it be Processed",this);
		      if (d10.Status() == 1)   
		      {
			 Flist  =  source_file.list();
                         mesgbox d11 = new mesgbox(this,"Mesgbox");
			 String mesg = "Copy the Directory "+item; 
			 d11.DisplayPath(DirName2);
			 int x = d11.disply(mesg,3,false,true); 
                         if (x==1)
			 {
			     flag = true; 
			     String str2 = d11.GetTextDest(); 
			     for (int i=0;i<Flist.length;i++)
          	  	     {	
				 System.out.println("inside loop");
                 	         copyfile copy = new copyfile(str1+File.separator+Flist[i],str2+File.separator+Flist[i],this);
				 DirName2 = str2;
		             }	

		         }
		      }	

	         }
                 else
		 {
		    mesgbox d = new mesgbox(this,"Mesgbox");
                    String mesg = "Copy the File "+ item; 	
                    String item2 = DirName2+File.separator+inactive.GetSelectedItem(); 
		    d.DisplayPath(item2);
		    int x = d.disply(mesg,3,false,true);
	            System.out.println("x = "+x); 	  
		    if (x == 1)
                    {
		 	String str2 = d.GetTextDest();
			StringTokenizer tokens = new StringTokenizer(str2,File.separator);
                        int n= tokens.countTokens();
			DirName2 = File.separator+tokens.nextToken();
			n=n-2;
			while (n!=0)
			{
			   DirName2= DirName2+File.separator+tokens.nextToken();
			   n--;
			}
			File dest_file = new File(str2);
			if (dest_file.isDirectory())
			{ 
			    flag1 = true;
			    DirName2= str2;
		            str2 = str2+File.separator+item;
			}
			item = tokens.nextToken();
			System.out.println("Str2 ="+str2);
                 	copyfile copy = new copyfile(str1,str2,this);
	            } 
		}
           }


 public void DeleteFile()          
 {
    item = active.GetSelectedItem(); 
    String DirName = active.DirPathName();
    String Item = DirName+File.separator+item;
    File source_file = new File(Item);
    mesgbox d2 = new mesgbox(this,"Messge Box"); 
    if (source_file.isDirectory())
    {
       	String [] flist = source_file.list();
 	String mesg ="Delete the Directory "+item;
 	int x = d2.disply(mesg,3,false,false);
	if (x ==1)
	{
	   for(int i=0;i<flist.length;i++)
           {	
	      //Item = Item+File.separator+flist[i];
	      source_file = new File(Item+File.separator+flist[i]);
	      if (source_file.exists())
            	 System.out.println("File ExistS");
 	       boolean status = source_file.delete();
			      System.out.println("Status = "+status);
			      if (status)
				 active.DelSelectedIndex(Item);
			   }
			}
                 } 
		 else
      	         {
                        String mesg = "Delete the File "+item; 
			int x = d2.disply(mesg,3,false,false);
		 	if (x == 1)
		  	{
			      item = DirName+File.separator+item;  
			      source_file = new File(item); 
			      boolean status = source_file.delete();
			      System.out.println("status= "+status);
			      if (status)
				 active.DelSelectedIndex(DirName);
		        }	
		}
       	}

        public void RenameFile()   
	   {
		item = active.GetSelectedItem(); 
		mesgbox d3 = new mesgbox(this,"Mesg box");
		String mesg = "Renaming the File  "+item;
		DirName1 =  active.DirPathName();
		File source_file = new File(DirName1,item);
		if (source_file.isDirectory())
		     mesg = "Renaming the directory "+item;
		int x = d3.disply(mesg,3,false,true);
		if (x == 1)
		{
			String str2 = d3.GetTextDest();
			File newfile = new File(DirName1,str2);
	        	boolean status = source_file.renameTo(newfile);
			System.out.println("Status="+status);
			if (status)  active.SetNewName(str2,DirName1);
		}
            }
          
      public void MoveFile() 
      {
	    flag2 = true;
	    item = active.GetSelectedItem();
	    boolean status=false;
	    mesgbox d12 = new mesgbox(this,"Mesg box");
            DirName1 = active.DirPathName();
            DirName2 = inactive.DirPathName();
            String mesg = "Moving the File  "+item;
	    File source_file = new File(DirName1,item);
	    if (source_file.isDirectory())
		 mesg = "Moving the Directory "+item;
	    d12.DisplayPath(DirName2);
            int x= d12.disply(mesg,3,false,true);
	     flag = false;
	    
	    if (x==1)
	    {
		 DirName2 = d12.GetTextDest();
	   	 String str1 = DirName1+File.separator+item;
	    	 String str2 = DirName2+File.separator+item; 
	         if (source_file.isDirectory())
                 {
	             Flist= source_file.list();
		     DirName1 = str1;
		     for (int i=0;i<Flist.length;i++)
		     {
			 source_file = new  File(str1,Flist[i]); 
			 str1 = str1+File.separator+Flist[i]; 
			 str2 = DirName2 +File.separator+Flist[i];
  	    	 	 copyfile copy = new copyfile(str1,str2,this);
		 	 status = source_file.delete();
  	    	 	 active.DelSelectedIndex(DirName1);
	             }	
	         }	
		 else
		 {
		     copyfile copy = new copyfile(str1,str2,this);
		     status = source_file.delete();
		     active.DelSelectedIndex(DirName1);
		  }    
      	    } 
            
       }

      public void FileProperty()  
      {
	    item = active.GetSelectedItem();
	    String DirName = active.DirPathName();
	    properties d5 = new properties(this,item,DirName);
      }

      public void MakeDir()
      {
            messgbox d6 = new messgbox(this,"Message Box"); 	
            int x = d6.disply("Create Directory",3,false,false);
	    String str = d6.GetTextSource();
            String DirName = active.DirPathName();
	    File fileobj = new File(DirName,str);
	    boolean status = fileobj.mkdir();
	    System.out.println("status = "+status);
	    active.UpdateItem(str,DirName,flag1);
      }        
      
      public void SearchFile()
      {
            String DirName = active.DirPathName();
	    messgbox d7 = new messgbox(this,"Message Box");
	    int x = d7.disply("Enter the File to be Searched",3,true,true);
            if(x == 1)
	    {
	       String str = d7.GetTextSource();
	       System.out.println("Str : "+str);
	       System.out.println("Before"+DirName);
	       String sDirName  = d7.GetTextDest();
	       System.out.println("After"+sDirName);
	       boolean found  =  search(sDirName,str);
	       if (!found)
	          DialogBox d9 = new DialogBox("File Not Found",this);

            }
       }
             
      public void QuitShell()
      {
	  	System.exit(0);
      }

      public void SortByName()
      {
   	   item = active.GetSelectedItem();
	   String DirName = active.DirPathName();
	   File fileobj = new File(DirName);
	   active.sorting(fileobj);
      }

      public void SortBySize()
      {
	   String DirName = active.DirPathName();
	   File fileobj = new File(DirName);
	   active.sortsize(fileobj);
      }

      public void SortByDate()
      {
           String DirName = active.DirPathName(); 
	   File fileobj = new File(DirName);
	   active.sortdate(fileobj);
      }



  public boolean  search(String args,String file)
  {
	String name[]; 
	String temp;
	String filename;

        File infile =  new File(args);
	name  = infile.list();
	
	for(int i=0;i<name.length;i++)
	{
	   if ((file.compareTo(name[i])) == 0)
	   {
	    	System.out.println("Found");
		System.out.println(name[i]);
		File newfile = new File(args+File.separator+name[i]);
		String st = "File Found? Absolute Path? is?"+newfile.getPath(); 
                DialogBox d8 = new DialogBox(st,this);  
		found = true;
		break;
	   }
           else
	   {
	   	filename = args+File.separator+name[i];
	   	File fnew = new File(filename);
	   	System.out.println(filename);
	   	if (fnew.isDirectory())
	   	{
			temp = fnew.getPath();
			 boolean status = search(temp,file);
	   	}
           } 
        }
	return found;
  }

  public void FileView()
  {
   	item = active.GetSelectedItem(); 
   	String DirName = active.DirPathName();
    	String Item = DirName+File.separator+item;
   	File source_file = new File(Item);
    	mesgbox d13 = new mesgbox(this,"Messge Box"); 
        if (source_file.isDirectory())
        {
	    String st = "item is Directory? Double click/Enter to see ?Files in the Directory";
	    DialogBox d14 = new  DialogBox(st,this);
        }
	else
	{
 	   String mesg ="Want to View the file "+item+"?";
 	   int x = d13.disply(mesg,3,false,false);
	   if (x == 1)
              try
	      {
	         FileViewer fv = new FileViewer(Item); 
              }catch (IOException e){  }
	       
	}
  }   
  

}
